#! /bin/bash
# .eml contact to vcard converter, 2019-12-08 James Spong / FatMac IT Solutions
# Test first, use wisely and remember; with great power, comes great responsibility

# ask user for source folder and assign to var
read -p "Enter the absolute file path of the folder containing the .eml Files": SRC

# assign variables
BACKUP="$SRC/eml-backup"
ORIGINAL="$SRC/eml-originals"
DEST="$SRC/eml-to-vcf-output"
MERGED="$SRC/merged-vcfs"

# make new BACKUP directory
mkdir -p $BACKUP

# make new ORIGINAL directory
mkdir -p $ORIGINAL

# make new DEST directory
mkdir -p $DEST

# make new MERGED directory
mkdir -p $MERGED

# change directory to SRC
cd $SRC

# move SRC emls to ORIGINAL directory
find $SRC -name '*.eml' -exec mv {} $ORIGINAL \;

# backup ORIGINAL directory as tar.gz, save in BACKUP directory
tar --exclude="$BACKUP" --exclude="$DEST" --exclude="$MERGED" -zcvf $BACKUP/eml-files.tar.gz $ORIGINAL

# change directory to ORIGINAL
cd $ORIGINAL

# echo status and loop through command
for vcard in *.eml
do
echo "processing $vcard"

# change DOS CR/LF to *nix line endings and strip the header of the message
# then output the „correct“ VCards to the backup directory
sed -e 's/.$// ; 1,/^$/ d' < $vcard | iconv -f UTF8 -t MACROMAN > $DEST/${vcard/%eml/vcf}
done;

# merge all vcards into one .vcf
# cat $DEST/*.vcf > $MERGED/merged-vcards.vcf
find $DEST -name "*.vcf" -exec cat '{}' ';' > $MERGED/merged-vcards.vcf

echo ""
echo "     ___             /  /  /"
echo "\ / |__   /\  |__|  /  /  / "
echo " |  |___ /~~\ |  | .  .  .  "
echo "                            "
echo ""